#include "stdafx.h"
#include "rsrc/resource.h"
#include "GpMain.h"
using namespace ki;
using namespace editwing;



//-------------------------------------------------------------------------
// VKvZXN
//-------------------------------------------------------------------------

void BootNewProcess( const TCHAR* cmd = TEXT("") )
{
	STARTUPINFO         sti;
	PROCESS_INFORMATION psi;
	::GetStartupInfo( &sti );

	String fcmd = Path(Path::ExeName).BeShortStyle();
	fcmd += ' ';
	fcmd += cmd;

	if( ::CreateProcess( NULL, const_cast<TCHAR*>(fcmd.c_str()),
			NULL, NULL, FALSE, NORMAL_PRIORITY_CLASS, NULL, NULL,
			&sti, &psi ) )
	{
		::CloseHandle( psi.hThread );
		::CloseHandle( psi.hProcess );
	}
}



//-------------------------------------------------------------------------
// Xe[^Xo[
//-------------------------------------------------------------------------

inline GpStBar::GpStBar()
	: str_(NULL)
	, lb_(2)
{
}

inline void GpStBar::SetCsText( const TCHAR* str )
{
	// R[h\̈SetText
	SetText( str_=str, 1 );
}

inline void GpStBar::SetLbText( int lb )
{
	// sR[h\̈SetText
	static const TCHAR* lbstr[] = {TEXT("CR"),TEXT("LF"),TEXT("CRLF")};
	SetText( lbstr[lb_=lb], 2 );
}

int GpStBar::AutoResize( bool maximized )
{
	// R[h\̈mۂTCY
	int h = StatusBar::AutoResize( maximized );
	int w[] = { width()-5, width()-5, width()-5 };

	HDC dc = ::GetDC( hwnd() );
	SIZE s;
	if( ::GetTextExtentPoint32( dc, TEXT("BBBBM"), 5, &s ) )
		w[1] = w[2] - s.cx;
	if( ::GetTextExtentPoint32( dc, TEXT("BBBBB"), 5, &s ) )
		w[0] = w[1] - s.cx;
	::ReleaseDC( hwnd(), dc );

	SetParts( countof(w), w );
	SetCsText( str_ );
	SetLbText( lb_ );
	return h;
}



//-------------------------------------------------------------------------
// fBXpb`
//-------------------------------------------------------------------------

LRESULT GreenPadWnd::on_message( UINT msg, WPARAM wp, LPARAM lp )
{
	switch( msg )
	{
	// ANeBuBEditCtrlɃtH[JXB
	case WM_ACTIVATE:
		if( LOWORD(wp) != WA_INACTIVE )
			edit_.SetFocus();
		break;

	// TCYύXBqKɈړB
	case WM_SIZE:
		if( wp != SIZE_MINIMIZED )
		{
			int ht = stb_.AutoResize( wp==SIZE_MAXIMIZED );
			edit_.MoveTo( 0, 0, LOWORD(lp), HIWORD(lp)-ht );
		}
		break;

	// VXeR}hBI{^ƂB
	case WM_SYSCOMMAND:
		if( wp==SC_CLOSE || wp==SC_DEFAULT )
			on_exit();
		else
			return WndImpl::on_message( msg, wp, lp );
		break;

	// ENbNj[
	case WM_CONTEXTMENU:
		::TrackPopupMenu(
			::GetSubMenu( ::GetMenu(hwnd()), 1 ), // ҏWj[\
			TPM_LEFTALIGN|TPM_TOPALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON,
			LOWORD(lp), HIWORD(lp), 0, hwnd(), NULL );
		break;

	// j[̃O[AEg
	case WM_INITMENU:
	case WM_INITMENUPOPUP:
		on_initmenu( reinterpret_cast<HMENU>(wp), msg==WM_INITMENUPOPUP );
		break;

	// cc
	case WM_DROPFILES:
		on_drop( reinterpret_cast<HDROP>(wp) );
		break;

	// MLU
	case GPM_MLUCHANGED:
		SetupMLUMenu();
		break;

	// ̑
	default:
		return WndImpl::on_message( msg, wp, lp );
	}

	return 0;
}

bool GreenPadWnd::on_command( UINT id, HWND ctrl )
{
	switch( id )
	{
	// Window
	case ID_CMD_NEXTWINDOW: on_nextwnd(); break;
	case ID_CMD_PREVWINDOW: on_prevwnd(); break;

	// File
	case ID_CMD_NEWFILE:    on_newfile();   break;
	case ID_CMD_OPENFILE:   on_openfile();  break;
	case ID_CMD_REOPENFILE: on_reopenfile();break;
	case ID_CMD_SAVEFILE:   on_savefile();  break;
	case ID_CMD_SAVEFILEAS: on_savefileas();break;
	case ID_CMD_EXIT:       on_exit();      break;

	// Edit
	case ID_CMD_UNDO:       edit_.getDoc().Undo();              break;
	case ID_CMD_REDO:       edit_.getDoc().Redo();              break;
	case ID_CMD_CUT:        edit_.getCursor().Cut();            break;
	case ID_CMD_COPY:       edit_.getCursor().Copy();           break;
	case ID_CMD_PASTE:      edit_.getCursor().Paste();          break;
	case ID_CMD_DELETE: if( edit_.getCursor().isSelected() )
	                        edit_.getCursor().Del();            break;
	case ID_CMD_SELECTALL:  edit_.getCursor().Home(true,false);
	                        edit_.getCursor().End(true,true);   break;
	case ID_CMD_DATETIME:   on_datetime();                      break;

	// Search
	case ID_CMD_FIND:       search_.ShowDlg();  break;
	case ID_CMD_FINDNEXT:   search_.FindNext(); break;
	case ID_CMD_FINDPREV:   search_.FindPrev(); break;
	case ID_CMD_JUMP:       on_jump(); break;
	case ID_CMD_GREP:       on_grep();break;

	// View
	case ID_CMD_NOWRAP:     edit_.getView().SetWrapType( wrap_=-1 ); break;
	case ID_CMD_WRAPWIDTH:  edit_.getView().SetWrapType( wrap_=cfg_.wrapWidth() ); break;
	case ID_CMD_WRAPWINDOW: edit_.getView().SetWrapType( wrap_=0 ); break;
	case ID_CMD_CONFIG:     on_config();

	// DocType
	default: if( ID_CMD_DOCTYPE <= id ) {
			on_doctype( id - ID_CMD_DOCTYPE );
			break;
		} else if( ID_CMD_MLU <= id ) {
			on_mlu( id - ID_CMD_MLU );
			break;
		}

	// Default
		return false;
	}
	return true;
}

bool GreenPadWnd::PreTranslateMessage( MSG* msg )
{
	// L[{[hV[gJbg
	return 0 != ::TranslateAccelerator( hwnd(), accel_, msg );
}



//-------------------------------------------------------------------------
// R}h
//-------------------------------------------------------------------------

void GreenPadWnd::on_dirtyflag_change( bool )
{
	UpdateWindowName();
}

void GreenPadWnd::on_newfile()
{
	BootNewProcess();
}

void GreenPadWnd::on_openfile()
{
	Path fn;
	int  cs;
	if( ShowOpenDlg( &fn, &cs ) )
		Open( fn, cs );
}

void GreenPadWnd::on_reopenfile()
{
	if( !isUntitled() )
	{
		ReopenDlg dlg( charSets_, csi_ );
		dlg.GoModal( hwnd() );
		if( dlg.endcode()==IDOK && AskToSave() )
			OpenByMyself( filename_, charSets_[dlg.csi()].ID, false );
	}
}

void GreenPadWnd::on_savefile()
{
	Save_showDlgIfNeeded();
}

void GreenPadWnd::on_savefileas()
{
	if( ShowSaveDlg() )
	{
		Save();
		ReloadConfig(); // ^Cvɉĕ\XV
	}
}

void GreenPadWnd::on_exit()
{
	if( AskToSave() )
		Destroy();
}

void GreenPadWnd::on_initmenu( HMENU menu, bool editmenu_only )
{
	MENUITEMINFO mi = { sizeof(MENUITEMINFO), MIIM_STATE };

	mi.fState =
		(edit_.getCursor().isSelected() ? MFS_ENABLED : MFS_DISABLED);
	SetMenuItemInfo( menu, ID_CMD_CUT, FALSE, &mi );
	SetMenuItemInfo( menu, ID_CMD_COPY, FALSE, &mi );
	SetMenuItemInfo( menu, ID_CMD_DELETE, FALSE, &mi );

	mi.fState =
		(edit_.getDoc().isUndoAble() ? MFS_ENABLED : MFS_DISABLED);
	SetMenuItemInfo( menu, ID_CMD_UNDO, FALSE, &mi );

	mi.fState =
		(edit_.getDoc().isRedoAble() ? MFS_ENABLED : MFS_DISABLED);
	SetMenuItemInfo( menu, ID_CMD_REDO, FALSE, &mi );

	if( editmenu_only )
		return;

	mi.fState = (isUntitled() || edit_.getDoc().isModified()
		? MFS_ENABLED : MFS_DISABLED);
	SetMenuItemInfo( menu, ID_CMD_SAVEFILE, FALSE, &mi );

	mi.fState =
		(!isUntitled() ? MFS_ENABLED : MFS_DISABLED);
	SetMenuItemInfo( menu, ID_CMD_REOPENFILE, FALSE, &mi );

	mi.fState =
		(cfg_.grepExe().len()>0 ? MFS_ENABLED : MFS_DISABLED);
	SetMenuItemInfo( menu, ID_CMD_GREP, FALSE, &mi );

	UINT id = (wrap_==-1 ? ID_CMD_NOWRAP
		: (wrap_>0 ? ID_CMD_WRAPWIDTH : ID_CMD_WRAPWINDOW));
	::CheckMenuRadioItem(
		menu, ID_CMD_NOWRAP, ID_CMD_WRAPWINDOW, id, MF_BYCOMMAND );
}

void GreenPadWnd::on_drop( HDROP hd )
{
	UINT iMax = ::DragQueryFile( hd, 0xffffffff, NULL, 0 );
	for( UINT i=0; i<iMax; ++i )
	{
		TCHAR str[MAX_PATH];
		::DragQueryFile( hd, i, str, countof(str) );
		Open( str, AutoDetect );
	}
	::DragFinish( hd );
}

void GreenPadWnd::on_jump()
{
	struct JumpDlg : public DlgImpl {
		JumpDlg(HWND w) : DlgImpl(IDD_JUMP), w_(w) { GoModal(w); }
		void on_init() {
			SetCenter(hwnd(),w_); ::SetFocus(item(IDC_LINEBOX)); }
		bool on_ok() {
			TCHAR str[100];
			::GetWindowText( item(IDC_LINEBOX), str, countof(str) );
			LineNo = String(str).GetInt();
			return true;
		}
		int LineNo; HWND w_;
	} dlg(hwnd());

	if( IDOK == dlg.endcode() )
		JumpToLine( dlg.LineNo );
}

void GreenPadWnd::on_grep()
{
	Path g = cfg_.grepExe();
	if( g.len() != 0 )
	{
		String fcmd;
		for( int i=0, e=g.len(); i<e; ++i )
			if( g[i]==TEXT('%') && g[i+1]==TEXT('1') )
				++i, fcmd += Path(Path::Cur,false);
			else
				fcmd += g[i];

		PROCESS_INFORMATION psi;
		STARTUPINFO         sti = {sizeof(STARTUPINFO)};
		sti.dwFlags = STARTF_USESHOWWINDOW;
		sti.wShowWindow = SW_SHOWNORMAL;
		if( ::CreateProcess( NULL, const_cast<TCHAR*>(fcmd.c_str()),
				NULL, NULL, FALSE, NORMAL_PRIORITY_CLASS, NULL, NULL,
				&sti, &psi ) )
		{
			::CloseHandle( psi.hThread );
			::CloseHandle( psi.hProcess );
		}
	}
}

void GreenPadWnd::on_datetime()
{
	TCHAR buf[255], tmp[255];
	::GetTimeFormat
		( LOCALE_USER_DEFAULT, 0, NULL, TEXT("HH:mm "), buf, countof(buf));
	::GetDateFormat
		( LOCALE_USER_DEFAULT, 0, NULL, TEXT("yy/MM/dd"),tmp,countof(tmp));
	::lstrcat( buf, tmp );
	edit_.getCursor().Input( buf, ::lstrlen(buf) );
}

void GreenPadWnd::on_doctype( int no )
{
	if( HMENU m = ::GetSubMenu( ::GetSubMenu(::GetMenu(hwnd()),3),4 ) )
	{
		cfg_.SetDocTypeByMenu( no, m );
		ReloadConfig( true );
	}
}

void GreenPadWnd::on_config()
{
	if( cfg_.DoDialog(*this) )
	{
		SetupSubMenu();
		SetupMLUMenu();
		ReloadConfig(false);
	}
}

static inline void MyShowWnd( HWND wnd )
{
	if( ::IsIconic(wnd) )
		::ShowWindow( wnd, SW_RESTORE );
	::BringWindowToTop( wnd );
}

void GreenPadWnd::on_nextwnd()
{
	if( HWND next = ::FindWindowEx( NULL, hwnd(), className_, NULL ) )
	{
		HWND last=next, pos;
		while( last != NULL )
			last = ::FindWindowEx( NULL, pos=last, className_, NULL );
		if( pos != next )
			::SetWindowPos( hwnd(), pos,
				0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE|SWP_SHOWWINDOW );
		MyShowWnd( next );
	}
}

void GreenPadWnd::on_prevwnd()
{
	HWND pos=NULL, next=::FindWindowEx( NULL,NULL,className_,NULL );
	if( next==hwnd() )
	{
		while( next != NULL )
			next = ::FindWindowEx( NULL,pos=next,className_,NULL );
		if( pos!=hwnd())
			MyShowWnd( pos );
	}
	else
	{
		while( next!=hwnd() && next!=NULL )
			next = ::FindWindowEx( NULL,pos=next,className_,NULL );
		if( next!=NULL )
			MyShowWnd( pos );
	}
}

void GreenPadWnd::on_move( const DPos& c, const DPos& s )
{
	ulong cad = c.ad;
	if( ! cfg_.countByUnicode() )
	{
		// ShiftJISByteJEg
		const unicode* cu = edit_.getDoc().tl(c.tl);
		cad = 0;
		for( ulong i=0; i<c.ad; ++i )
			cad += (cu[i]<0x80 || 0xff60<=cu[i] && cu[i]<=0xff9f ? 1 : 2);
	}

	String str;
	str += TEXT('(');
	str += String().SetInt(c.tl+1);
	str += TEXT(',');
	str += String().SetInt(cad+1);
	str += TEXT(')');
	if( c != s )
	{
		ulong sad = s.ad;
		if( ! cfg_.countByUnicode() )
		{
			// ShiftJISByteJEg
			const unicode* su = edit_.getDoc().tl(s.tl);
			sad = 0;
			for( ulong i=0; i<s.ad; ++i )
				sad += (su[i]<0x80 || 0xff60<=su[i] && su[i]<=0xff9f ? 1 : 2);
		}
		str += TEXT(" - (");
		str += String().SetInt(s.tl+1);
		str += TEXT(',');
		str += String().SetInt(sad+1);
		str += TEXT(')');
	}
	stb_.SetText( str.c_str() );
}



//-------------------------------------------------------------------------
// [eBeB[
//-------------------------------------------------------------------------

void GreenPadWnd::JumpToLine( ulong ln )
{
	edit_.getCursor().MoveCur( DPos(ln-1,0), false );
}

void GreenPadWnd::SetupSubMenu()
{
	if( HMENU m = ::GetSubMenu( ::GetSubMenu(::GetMenu(hwnd()),3),4 ) )
	{
		cfg_.SetDocTypeMenu( m, ID_CMD_DOCTYPE );
		::DrawMenuBar( hwnd() );
	}
}

void GreenPadWnd::UpdateWindowName()
{
	// ^Cgo[ɕ\镶̒
	// [FileName *] - GreenPad
	String name;
	name += TEXT('[');
	name += isUntitled() ? TEXT("untitled") : filename_.name();
	if( edit_.getDoc().isModified() ) name += TEXT(" *");
	name += TEXT("] - ");
	name += String(IDS_APPNAME).c_str();

	SetText( name.c_str() );
	stb_.SetCsText( charSets_[csi_].shortName );
	stb_.SetLbText( lb_ );
}

void GreenPadWnd::SetupMLUMenu()
{
	if( HMENU m = ::GetSubMenu( ::GetSubMenu(::GetMenu(hwnd()),0),8 ) )
	{
		cfg_.SetUpMLUMenu( m, ID_CMD_MLU );
		::DrawMenuBar( hwnd() );
	}
}

void GreenPadWnd::on_mlu( int no )
{
	Path fn = cfg_.GetMLU(no);
	if( fn.len() != 0 )
		Open( fn, AutoDetect );
}



//-------------------------------------------------------------------------
// ݒXV
//-------------------------------------------------------------------------

void GreenPadWnd::ReloadConfig( bool noSetDocType )
{
	// ^Cv[h
	if( !noSetDocType )
	{
		int t = cfg_.SetDocType( filename_ );
		if( HMENU m = ::GetSubMenu( ::GetSubMenu(::GetMenu(hwnd()),3),4 ) )
			cfg_.CheckMenu( m, t );
	}

	// Undo񐔐
	edit_.getDoc().SetUndoLimit( cfg_.undoLimit() );

	// sԍ
	bool ln = cfg_.showLN();
	edit_.getView().ShowLineNo( ln );

	// ܂Ԃ
	wrap_ = cfg_.wrapType();
	edit_.getView().SetWrapType( wrap_ );

	// FEtHg
	VConfig vc = cfg_.vConfig();
	edit_.getView().SetFont( vc );

	// L[[ht@C
	Path kwd = cfg_.kwdFile();
	FileR fp;
	if( kwd.len()!=0 && fp.Open(kwd.c_str()) )
		edit_.getDoc().SetKeyword((const unicode*)fp.base(),fp.size()/2);
	else
		edit_.getDoc().SetKeyword(NULL,0);
}



//-------------------------------------------------------------------------
// J
//-------------------------------------------------------------------------

bool GreenPadWnd::ShowOpenDlg( Path* fn, int* cs )
{
	// [Open][Cancel] Jt@Cw_CAO\

	String flst[] = {
		String(IDS_TXTFILES),
		String(cfg_.txtFileFilter()),
		String(IDS_ALLFILES),
		String(TEXT("*.*"))
	};
	aarr<TCHAR> filt = OpenFileDlg::ConnectWithNull(flst,countof(flst));

	OpenFileDlg ofd( charSets_ );
	if( ofd.DoModal( hwnd(), filt.get(), filename_.c_str() ) )
	{
		*fn = ofd.filename();
		*cs = charSets_[ofd.csi()].ID;
		return true;
	}

	return false;
}

bool GreenPadWnd::Open( const Path& fn, int cs )
{
	if( isUntitled() && !edit_.getDoc().isModified() )
	{
		// ŖύX玩ŊJ
		return OpenByMyself( fn, cs );
	}
	else
	{
		// ŊJ[hȂ炻
		if( cfg_.openSame() )
			return ( AskToSave() ? OpenByMyself( fn, cs ) : true );

		// łȂΑ։
		String
			cmd  = TEXT("-c");
			cmd += String().SetInt( cs );
			cmd += TEXT(" \"");
			cmd += fn;
			cmd += TEXT('\"');
		BootNewProcess( cmd.c_str() );
		return true;
	}
}

bool GreenPadWnd::OpenByMyself( const Path& fn, int cs, bool needReConf )
{
	// t@CJȂ炻ł܂B
	aptr<TextFileR> tf( new TextFileR(cs) );
	if( !tf->Open( fn.c_str() ) )
	{
		// ERROR!
		MsgBox( String(IDS_OPENERROR).c_str() );
		return false;
	}

	// ̊ǗXV
	filename_ = fn;
	csi_      = charSets_.findCsi( tf->codepage() );
	lb_       = tf->linebreak();
	filename_.BeShortLongStyle();

	// [ŋߎgt@C]֒ǉ
	cfg_.AddMLU( filename_ );
	HWND wnd = NULL;
	while( NULL!=(wnd=::FindWindowEx( NULL, wnd, className_, NULL )) )
		SendMessage( wnd, GPM_MLUCHANGED, 0, 0 );

	// ^Cvɉĕ\XV
	if( needReConf )
		ReloadConfig();

	// J
	edit_.getDoc().ClearAll();
	edit_.getDoc().OpenFile( tf );

	// ^Cgo[XV
	UpdateWindowName();
	return true;
}



//-------------------------------------------------------------------------
// ۑ
//-------------------------------------------------------------------------

bool GreenPadWnd::ShowSaveDlg()
{
	// [Save][Cancel] ۑt@Cw_CAO\

	String flst[] = {
		String(IDS_ALLFILES),
		String(TEXT("*.*"))
	};
	aarr<TCHAR> filt = SaveFileDlg::ConnectWithNull( flst, countof(flst) );

	SaveFileDlg sfd( charSets_, csi_, lb_ );
	if( !sfd.DoModal( hwnd(), filt.get(), filename_.c_str() ) )
		return false;

	filename_ = sfd.filename();
	csi_      = sfd.csi();
	lb_       = sfd.lb();

	return true;
}

bool GreenPadWnd::Save_showDlgIfNeeded()
{
	bool wasUntitled = isUntitled();

	// [Save][Cancel] t@CȂ_CAO\
	if( isUntitled() )
		if( !ShowSaveDlg() )
			return false;
	if( Save() )
	{
		if( wasUntitled )
			ReloadConfig(); // ^Cvɉĕ\XV
		return true;
	}
	return false;
}

bool GreenPadWnd::AskToSave()
{
	// ύXĂA
	// [Yes][No][Cancel] ۑ邩ǂq˂B
	// ۑȂ
	// [Save][Cancel]    t@CȂ_CAO\

	if( edit_.getDoc().isModified() )
	{
		int answer = MsgBox(
			String(IDS_ASKTOSAVE).c_str(),
			String(IDS_APPNAME).c_str(),
			MB_YESNOCANCEL|MB_ICONQUESTION
		);
		if( answer == IDYES )    return Save_showDlgIfNeeded();
		if( answer == IDCANCEL ) return false;
	}
	return true;
}

bool GreenPadWnd::Save()
{
	TextFileW tf( charSets_[csi_].ID, lb_ );
	if( tf.Open( filename_.c_str() ) )
	{
		// t@Cɕۑłꍇ
		edit_.getDoc().SaveFile( tf );
		UpdateWindowName();
		// [ŋߎgt@C]XV
		cfg_.AddMLU( filename_ );
		HWND wnd = NULL;
		while( NULL!=(wnd=::FindWindowEx( NULL, wnd, className_, NULL )) )
			SendMessage( wnd, GPM_MLUCHANGED, 0, 0 );
		return true;
	}

	// Error!
	MsgBox( String(IDS_SAVEERROR).c_str() );
	return false;
}



//-------------------------------------------------------------------------
// CEChȄ
//-------------------------------------------------------------------------

GreenPadWnd::ClsName GreenPadWnd::className_ = TEXT("GreenPad MainWnd");

GreenPadWnd::GreenPadWnd()
	: WndImpl  ( className_, WS_OVERLAPPEDWINDOW, WS_EX_ACCEPTFILES )
	, csi_     ( charSets_.defaultCsi() )
	, lb_      ( CRLF )
	, search_  ( edit_ )
{
	static WNDCLASSEX wc;
	wc.hIcon         = app().LoadIcon( IDR_MAIN );
	wc.hCursor       = app().LoadOemCursor( IDC_ARROW );
	wc.lpszMenuName  = MAKEINTRESOURCE( IDR_MAIN );
	wc.lpszClassName = className_;
	WndImpl::Register( &wc );

	ime().EnableGlobalIME( true );
}

void GreenPadWnd::on_create( CREATESTRUCT* cs )
{
	accel_ = app().LoadAccel( IDR_MAIN );
	stb_.Create( hwnd() );
	edit_.Create( NULL, hwnd(), 0, 0, 100, 100 );
	edit_.getDoc().AddHandler( this );
	edit_.getCursor().AddHandler( this );
	SetupSubMenu();
	SetupMLUMenu();
}

bool GreenPadWnd::StartUp( const Path& fn, int cs, int ln )
{
	Create();
	if( fn.len()==0 || !OpenByMyself( fn, cs ) )
	{
		// t@CJ()Ȃꍇ
		ReloadConfig();
		UpdateWindowName();
	}

	// w̍sփWv
	if( ln != -1 )
		JumpToLine( ln );
	return true;
}



//-------------------------------------------------------------------------
// X^[gAbv[`
//	R}hC̉͂s
//-------------------------------------------------------------------------

int kmain()
{
	Argv  arg;
	ulong   i;

  //-- ܂IvVXCb`

	int optL = -1;
	int optC = 0;

	for( i=1; i<arg.size() && arg[i][0]==TEXT('-'); ++i )
		switch( arg[i][1] )
		{
		case TEXT('c'):
			optC = String::GetInt( arg[i]+2 );
			break;
		case TEXT('l'):
			optL = String::GetInt( arg[i]+2 );
			break;
		}

  //-- Ƀt@C

	Path file;

	if( i < arg.size() )
	{
		file = arg[i];
		if( !file.isFile() )
		{
			ulong j; // ""ŔXyłȂɑΏ
			for( j=i+1; j<arg.size(); ++j )
			{
				file += ' ';
				file += arg[j];
				if( file.isFile() )
					break;
			}

			if( j==arg.size() )
				file = arg[i];
			else
				i=j;
		}
	}

  //-- ]Ă΁AŐVKvZXN

	if( ++i < arg.size() )
	{
		String cmd;
		for( ; i<arg.size(); ++i )
		{
			cmd += TEXT('\"');
			cmd += arg[i];
			cmd += TEXT("\" ");
		}
		::BootNewProcess( cmd.c_str() );
	}

  //-- CEChEi

	GreenPadWnd wnd;
	if( !wnd.StartUp(file,optC,optL) )
		return -1;

  //-- C[v

	wnd.ShowUp();
	wnd.MsgLoop();
	return 0;
}
