#include "stdafx.h"
#include "ip_doc.h"
using namespace editwing;
using namespace editwing::doc;



//=========================================================================
//---- ip_parse.cpp L[[h
//
//		L[[h`t@Cɏ]āAێ镶
//		K؂ɐ؂蕪ƂB
//
//---- ip_text.cpp   񑀍E
//---- ip_wrap.cpp   ܂Ԃ
//---- ip_scroll.cpp XN[
//---- ip_draw.cpp   `E
//---- ip_cursor.cpp J[\Rg[
//=========================================================================



//=========================================================================
//
// ͌ʃf[^dl
// ꂾFXƑȎiŖ{
// ȂĂ̂ǂ͕sc(^^;
//
// -----------------------------------------------
//
// Line::isLineHeadCommented_
//    0: subNRg̓ł͂Ȃ
//    1: subNRg̓
//
// -----------------------------------------------
//
// Line::commentTransition_
//   00: s͏ɃRg̊O
//   01: sƍs̓RgԂt]
//   10: sƍs̓RgԂ
//   11: s͏ɃRg̒
//
// -----------------------------------------------
//
// ȏ̃tOɁAO̍s̏񂩂獡̍s̏
//   this.head = (prev.trans >> prev.head)&1;
// ŏvZĂƂoB
// ̌vZ̍ۂɓobt@̏Ԃ܂ŏ̂
// RXgł̂ŁAɎtOȂ
// `搡OɓKXB
//
// -----------------------------------------------
//
// Line::commentBitReady_
//   Rgrbgς݂ǂ
//
// -----------------------------------------------
//
// Line::str_[]
//   UCS-2x^ŁAf[^̂܂܊i[B
//   Ap[T̍̂߂ɍŏǏ
//   0x007ftB
//
// -----------------------------------------------
//
// Line::flg_
//   ꕶɁÂ悤8bit̃tO蓖Ă
//   | aaabbbcd |
// 
// -----------------------------------------------
//
// aaa == "PosInToken"
//     0: g[N̓r
//   1-6: g[N̓B̓1-6B
//     7: g[N̓B̓7ȏB
//
// -----------------------------------------------
//
// bbb == "TokenType"
//     0: TAB: ^u
//     1: WSP: zCgXy[X
//     2: TXT: ʂ̕
//     3:  CE: RgJn^O
//     4:  CB: RgI^O
//     5:  LB: sRgJn^O
//     6:  Q1: '' p1
//     7:  Q2: "" p2
//
// -----------------------------------------------
//
//  c  == "isKeyword?"
//     0: L[[hł͂Ȃ
//     1: L[[h
//
// -----------------------------------------------
//
//  d  == "inComment?"
//     0: Rg̒ł͂Ȃ
//     1: Rg̒
//
// -----------------------------------------------



namespace {
//-------------------------------------------------------------------------
// Rg̒Ȃ̂OȂ̂𔻒肷邽߂̃I[g}g
//
// /* o炻̌̓Rg */ o炻̌̓m[}][
// cƂPȋKł͏肭sȂBႦ str"/*"str ȂĂ̂
// oꍇɍĂ܂BŁA
//   Eʂ̃eLXg
//   EubNRg̒
//   EsRg̒
//   Edp̒
//   Edp̒
// ̂Tނ̏ԂɕāAꂼ̏ꍇɂāAǂ̋Lo
// ɂǂ̏ԂɈڂ̂cKvB̏ԕω̋K
// 5x5̂Qzŗ^ĊǗB
//-------------------------------------------------------------------------

enum CommentDFASymbol{ sCB, sCE, sLB, sQ1, sQ2, sXXX };
struct CommentDFA
{
	// <>
	// ŉbitA݃Rgǂ̃tOɂȂ܂B
	// ubNRgǂ (state>>1)&(state) ŁB
	//   000: normal text        011: in BlockComment
	//   001: in LineComment     100: in Quote2
	//   010: in Quote1
	//
	// <V{>
	// C++ŌƉ̒ʂ
	// lTokenTypetOƃVN悤ɂȂĂ܂B
	//   000: CE */              011: Q1 '
	//   001: CB /*              100: Q2 "
	//   010: LB //

	// ԂwBRgRgO
	CommentDFA( bool inComment )
		: state( inComment ? 3 : 0 ) {}

	// ͕^ďԑJ
	void transit( int sym ) 
		{ state = tr_table[state][sym]; }

	// ݂̏
	int state;

	// ԑJڃe[u
	static const int tr_table[5][5];
};

const int CommentDFA::tr_table[5][5] = {
	{0,3,1,2,4},
	{1,1,1,1,1},
	{2,2,2,0,2},
	{0,3,3,3,3},
	{4,4,4,4,0},
};



//-------------------------------------------------------------------------
// PȁAL[[hi[\́B
// ChainHash̗vfɂ邽next|C^Ă܂B
//-------------------------------------------------------------------------

struct Keyword : public Object
{
	unicode*    str;
	const ulong len;
	Keyword*   next;

	Keyword( const unicode* s, ulong l )
		: str( new unicode[l+1] )
		, len( l )
		, next( NULL )
		{ memcpy( str, s, l*sizeof(unicode) ); }

	~Keyword()
		{ delete [] str; }
};



//-------------------------------------------------------------------------
// T|[g֐BUnicodeeLXgm̔r
//-------------------------------------------------------------------------

static bool compare_s(const unicode* a,const unicode* b,ulong l)
{
	// 啶
	while( l-- )
		if( *a++ != *b++ )
			return false;
	return true;
}

static bool compare_i(const unicode* a,const unicode* b,ulong l)
{
	// 啶ʂȂiGj
	while( l-- )
		if( ((*a++) ^ (*b++)) & 0xdf )
			return false;
	return true;
}



//-------------------------------------------------------------------------
// ^ꂽL񂩂ARgJn̈Ӗ̂g[N
// ؂oĂ邽߂̍\B
//-------------------------------------------------------------------------

class TagMap
{
	Keyword* tag_[3]; // 0:CE 1:CB 2:LB
	bool esc_, q1_, q2_, map_[128];

public:

	TagMap( const unicode* cb, ulong cblen,
		    const unicode* ce, ulong celen,
		    const unicode* lb, ulong lblen,
		    bool q1, bool q2, bool esc )
		: q1_ ( q1 )
		, q2_ ( q2 )
		, esc_( esc )
	{
		// '/' Ŏn܂L͎gĂ邩cH
		// ݂ȁAPڂ݂̂̃`FbNɎg\쐬
		tag_[0] = tag_[1] = tag_[2] = NULL;
		memset( map_, 0, sizeof(map_) );
		map_[L'\''] = q1;
		map_[L'\"'] = q2;
		map_[L'\\'] = esc;
		if( celen!=0 ){ map_[*ce]=true; tag_[0]=new Keyword(ce,celen); }
		if( cblen!=0 ){ map_[*cb]=true; tag_[1]=new Keyword(cb,cblen); }
		if( lblen!=0 ){ map_[*lb]=true; tag_[2]=new Keyword(lb,lblen); }
	}

	~TagMap()
	{
		// L[[h
		delete tag_[0];
		delete tag_[1];
		delete tag_[2];
	}

	bool does_esc()
	{
		// \ ɂGXP[v邩ǂ
		return esc_;
	}

	ulong SymbolLoop(
		const unicode* str, ulong len, ulong& mlen, int& sym )
	{
		// LӖȋLɃ}b`܂Ń[v
		// ԒlɁA}b`܂łɔ΂A
		// mlen,symɁA}b`L̏Ԃ

		int i;
		ulong ans=0;
		for( sym=sXXX, mlen=1; ans<len; ++ans )
			if( map_[str[ans]] )
			{
				for( i=2; i>=0; --i )
					if( tag_[i]!=NULL
					 && tag_[i]->len <= len-ans
					 && compare_s(
						tag_[i]->str, str+ans, tag_[i]->len ) )
					{
						sym  = i;
						mlen = tag_[i]->len;
						goto symbolfound;
					}
				if( str[ans] == L'\'' ) // dp
				{
					if( q1_ )
					{
						sym  = sQ1;
						goto symbolfound;
					}
				}
				else if( str[ans] == L'\"' ) // dp
				{
					if( q2_ )
					{
						sym  = sQ2;
						goto symbolfound;
					}
				}
				else if( str[ans] == L'\\' ) // \ ̌̕Skip
				{
					if( esc_ && ans+1<len )
						++ans;
				}
			}

	symbolfound:
		return ans;
	}
};



//-------------------------------------------------------------------------
// ^ꂽ񂪃L[[hǂ肷邽߂̃nbV\
//-------------------------------------------------------------------------

class KeywordMap
{
	Keyword*          backet_[4096];
	storage<Keyword*> dustbox_;
	bool (*compare_)(const unicode*,const unicode*,ulong);

public:

	KeywordMap( bool bCaseSensitive )
		: compare_( bCaseSensitive ? compare_s : compare_i )
	{
		// nbV\
		memset( backet_, 0, sizeof(backet_) );
	}

	~KeywordMap()
	{
		// 
		for( ulong i=0; i<dustbox_.size(); ++i )
			delete dustbox_[i];
	}

	void AddKeyword( const unicode* str, ulong len )
	{
		// f[^o^
		Keyword* x = new Keyword(str,len);
		int      h = hash(str,len);

		if( backet_[h] == NULL )
		{
			// nbVe[ȕꍇ
			backet_[h] = x;
		}
		else
		{
			// `FCɌqꍇ
			Keyword *q=backet_[h],*p=backet_[h]->next;
			while( p!=NULL )
				q=p, p=p->next;
			q->next = x;
		}

		// f[^NAp̃XgɂĂ
		dustbox_.Add(x);
	}

	ulong isKeyword( const unicode* str, ulong len )
	{
		// o^ĂL[[hƈv邩H
		for( Keyword* p=backet_[hash(str,len)]; p!=NULL; p=p->next )
			if( p->len==len && compare_( p->str, str, len ) )
				return 2;
		return 0;
	}

private:

	static int hash( const unicode* a, ulong al )
	{
		// 12bitɒׂ߂GȃnbV֐
		// [`̖ʓ|Ȃ̂ŁA啶͏ɋʂȂB(^^;
		int h=0,i=0;
		while( al-- )
		{
			h ^= ((*a&0xdf)<<i);
			i = (i+5)&7;
		}
		return h&4095;
	}
};



//-------------------------------------------------------------------------
// ȏ̓ĂłāAeLXg̉͂sParser
//-------------------------------------------------------------------------
}

class editwing::doc::Parser
{
	KeywordMap kwd_;
	TagMap     tag_;

public:
	// P
	Parser(
		const unicode* cb, ulong cblen,
		const unicode* ce, ulong celen,
		const unicode* lb, ulong lblen,
		bool q1, bool q2, bool esc,
		bool casesensitive
	)
		: tag_( cb, cblen, ce, celen, lb, lblen, q1, q2, esc )
		, kwd_( casesensitive )
	{
	}

	// QFL[[hǉ
	void AddKeyword( const unicode* str, ulong len )
	{
		kwd_.AddKeyword( str, len );
	}

	// sf[^
	uchar Parse( Line& line, uchar cmst )
	{
		line.TransitCmt( cmst );

		// ASCIIU蕪e[uB
		// VtgTokenTypeɗpo悤ɂ邽߁A
		// lSтɂȂĂ܂
		enum { T=0, W=4, A=8, S=12, O=0 };
		static const uchar letter_type[128] = {
			O,O,O,O,O,O,O,O,O,T,O,O,O,O,O,O,
			O,O,O,O,O,O,O,O,O,O,O,O,O,O,O,O,
			W,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,
			A,A,A,A,A,A,A,A,A,A,S,S,S,S,S,S,
			S,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,
			A,A,A,A,A,A,A,A,A,A,A,S,S,S,S,A,
			S,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,
			A,A,A,A,A,A,A,A,A,A,A,S,S,S,S,O,
		};

		// PosInTokenZop̋GR[_( 5bitVtgς )
		//  ( _d>7 ? 7<<5 : _d<<5 )
		#define tkenc(_d) ( (_d)>7 ? 0xe0 : (_d)<<5 )

		// RgԑJڒǐ՗pI[g}g
		CommentDFA dfa[2] = {CommentDFA(false), CommentDFA(true)};
		int& cmtState  = dfa[line.isLineHeadCmt()].state;
		int commentbit = cmtState&1;

		// Ɨ̈
		int sym;
		ulong j, k, um, m;
		uchar t, f;

		// [v`
		const unicode* str = line.str();
		uchar*         flg = line.flg();
		ulong           ie = line.size();
		for( ulong i=0; i<ie; i=j )
		{
			j = i;

			// ASCIIłȂꍇ
			if( str[i] >= 0x007f )
			{
				f = (ALP | commentbit);
				if( str[i] == 0x3000 )//L'@' )
					while( str[++j] == 0x3000 )
						flg[j] = f;
				else
					while( str[++j] >= 0x80 && str[j]!=0x3000 )
						flg[j] = f;
				flg[i] = static_cast<uchar>(tkenc(j-i) | f);
			}
			// ASCIȈꍇ??
			else
			{
				t = letter_type[str[i]];
				if( t==S && tag_.does_esc() )
					do
						if( str[j]==L'\\' && j+1<ie )
							j++;
					while( str[++j]<0x7f && S==letter_type[str[j]] );
				else
					while( str[++j]<0x7f && t==letter_type[str[j]] );

				f = (t | commentbit);

				switch( t )
				{
				// At@xbg
				case A:
					f |= kwd_.isKeyword( str+i, j-i );
					// fall...

				// ^uE䕶
				case T:
					// fall...

				// p
				case W:
					for( k=i+1; k<j; ++k )
						flg[k] = f;
					flg[i] = (uchar)(tkenc(j-i)|f);
					break;

				// L
				case S:
					k = i;
					while( k < j )
					{
						// }b`Ȃ
						um = tag_.SymbolLoop( str+k, j-k, m, sym );
						f = (0x20 | ALP | commentbit);
						while( um-- )
							flg[k++] = f;
						if( k >= j )
							break;

						// }b`
						f = (CE | commentbit);
						dfa[0].transit( sym );
						dfa[1].transit( sym );
						commentbit = cmtState&1;
						if( sym != 0 ) // 0:comment end
							f = (((sym+3)<<2) | commentbit);
						flg[k++] = (uchar)(tkenc(m)|f);
						while( --m )
							flg[k++] = f;
					}
					break;
				}
			}
		}

		// transittOXV
		line.SetTransitFlag(
			(dfa[1].state & (dfa[1].state<<1)) |
			((dfa[0].state>>1) & dfa[0].state)
		);
		line.CommentBitUpdated();
		return line.TransitCmt( cmst );
	}

	// Rgrbg𐳂
	void SetCommentBit( Line& line )
	{
		CommentDFA dfa( line.isLineHeadCmt()==1 );
		ulong commentbit = dfa.state&1;

		// [v`
		const unicode* str = line.str();
		uchar*         flg = line.flg();
		ulong       j,k,ie = line.size();
		for( ulong i=0; i<ie; i=j )
		{
			// Token̏I[𓾂
			k = (flg[i]>>5);
			j = i + k;
			if( j >= ie )
				j = ie;
			else if( k==7 ) // || k==0 )
				while( (flg[j]>>5)==0 && j<ie )
					++j;

			k = (flg[i] & 0x1c);
			if( k <= CE )
			{
				for( ; i<j; ++i )
					flg[i] = (uchar)((flg[i] & 0xfe) | commentbit);
			}
			if( k >= CE )
			{
				dfa.transit( (k>>2)-3 );
				commentbit = dfa.state&1;
				if( k != CE )
					for( ; i<j; ++i )
						flg[i] = (uchar)((flg[i] & 0xfe) | commentbit);
			}
		}

		line.CommentBitUpdated();
	}
};



//-------------------------------------------------------------------------
// `t@Cǂ݂Ƃ菈Ƃ
//-------------------------------------------------------------------------

DocImpl::~DocImpl()
{
	// ̃t@CɃfXgN^ĂȂƁA
	// delete parser_ oȂȂB^^;
}

void DocImpl::SetKeyword( const unicode* defbuf, ulong siz )
{
	// BOMXLbv
	if( siz!=0 && *defbuf==0xfeff )
		++defbuf, --siz;

	// ǂݍݏ
	const unicode* str;
	ulong          len;
	UniReader r( defbuf, siz, &str, &len );
	bool          flags[] = {false,false,false,false};
	const unicode* tags[] = {NULL,NULL,NULL};
	ulong        taglen[] = {0,0,0};

	if( siz != 0 )
	{
		// Ps:tO
		//   case? q1? q2? esc?
		r.getLine();
		for( ulong i=0; i<len; ++i )
			flags[i] = (str[i]==L'1');

		// Q`Ss
		//   uRJnLAuRILAsRL
		for( int j=0; j<3; ++j )
		{
			r.getLine();
			  tags[j] = str;
			taglen[j] = len;
		}
	}

	// p[T[쐬
	parser_ = new Parser(
		tags[0], taglen[0], tags[1], taglen[1], tags[2], taglen[2],
		flags[1], flags[2], flags[3], flags[0] );

	// Tsڈȍ~FL[[hXg
	while( !r.isEmpty() )
	{
		r.getLine();
		if( len != 0 )
			parser_->AddKeyword( str, len );
	}

	// Ss͂
	ReParse( 0, tln()-1 );

	// ύXʒm
	Fire_KEYWORDCHANGE();
}

bool DocImpl::ReParse( ulong s, ulong e )
{
	ulong i;
	uchar cmt = text_[s].isLineHeadCmt();

	// ܂͕ύX͈͂ĉ
	for( i=s; i<=e; ++i )
		cmt = parser_->Parse( text_[i], cmt );

	// RgAEgԂɕωȂ炱łIB
	if( i==tln() || text_[i].isLineHeadCmt()==cmt )
		return false;

	// Ⴆ΁A/* ͂ꂽꍇȂǂ́A̍̕s܂
	// RgAEgԂ̕ω`BKvB
	do
		cmt = text_[i++].TransitCmt( cmt );
	while( i<tln() && text_[i].isLineHeadCmt()!=cmt );
	return true;
}

void DocImpl::SetCommentBit( const Line& x ) const
{
	parser_->SetCommentBit( const_cast<Line&>(x) );
}
