#include "stdafx.h"
#include "ip_view.h"
using namespace editwing;
using namespace editwing::view;



//=========================================================================
//---- ip_wrap.cpp   ܂Ԃ
//
//		Documentŕf[^XV̂󂯂
//		Viewł͐܂ԂʒuXVB̏RRB
//
//---- ip_text.cpp   񑀍E
//---- ip_parse.cpp  L[[h
//---- ip_scroll.cpp XN[
//---- ip_draw.cpp   `E
//---- ip_cursor.cpp J[\Rg[
//=========================================================================



//-------------------------------------------------------------------------
// 
//-------------------------------------------------------------------------

ViewImpl::ViewImpl( View& vw, DocImpl& dc )
	: doc_   ( dc )
	, cvs_   ( vw )
	, cur_   ( vw.hwnd(), *this, dc )
	, hwnd_  ( vw.hwnd() )
	, vlNum_ ( 0 )
	, textCx_( 0 )
{
	// Kɐ܂Ԃ񏉊
	InsertMulti( 0, doc_.tln()-1 );

	// KɃXN[񏉊
	udScr_.cbSize = rlScr_.cbSize = sizeof(udScr_);
	udScr_.fMask  = rlScr_.fMask  = SIF_PAGE | SIF_POS | SIF_RANGE;
	udScr_.nMin   = rlScr_.nMin   = 0;
	udScr_.nPos   = rlScr_.nPos   = 0;
	udScr_.fMask |= SIF_DISABLENOSCROLL;
	udScr_tl_     = udScr_vrl_    = 0;
	ReSetScrollInfo();
}



//-------------------------------------------------------------------------
// ԕύXւ̑Ή
//-------------------------------------------------------------------------

void ViewImpl::DoResize( bool wrapWidthChanged )
{
	// ܂ԂʒuČvZ
	if( wrapWidthChanged )
	{
		ReWrapAll();
		UpdateTextCx();
	}

	// XN[ύX
	ReSetScrollInfo();
	if( wrapWidthChanged )
		ForceScrollTo( udScr_tl_ );

	// ĕ`
	ReDraw( ALL );
	cur_.ResetPos();
}

void ViewImpl::DoConfigChange()
{
	// ܂ԂʒuČvZ
	ReWrapAll();
	UpdateTextCx();

	// XN[ύX
	ReSetScrollInfo();
	ForceScrollTo( udScr_tl_ );

	// ĕ`
	ReDraw( ALL );
	cur_.ResetPos();
}

void ViewImpl::on_text_update
	( const DPos& s, const DPos& e, const DPos& e2, bool bAft, bool mCur )
{
	// ܂A܂ԂʒuČvZ

	// u͈͂̐擪s𒲐
	int r3 = 0, r2 = 1, r1 = ReWrapSingle( s );

	// c𒲐
	if( s.tl != e.tl )
		r2 = DeleteMulti( s.tl+1,  e.tl );
	if( s.tl != e2.tl )
		r3 = InsertMulti( s.tl+1, e2.tl );

	// ̕ύXŉc
	// if( "ȂȂĂ͂Ȃ" AND "ZȂ\" )
	//     ČvZ();
	if( !(r1==2 || r3==1) && (r1==0 || r2==0) )
		UpdateTextCx();

	// XN[o[C
	ReDrawType t = TextUpdate_ScrollBar( s, e, e2 );
	bool doResize = false;

	// sɕωāAsԍ\̕ςȂȂ
	if( e.tl!=e2.tl && cvs_.on_tln_change( doc_.tln() ) )
	{
		doResize = true;
	}
	else if( bAft && t!=ALL )
	{
		t = AFTER;
	}

	// J[\ړ
	cur_.on_text_update( s, e, e2, mCur );

	// ĕ`
	if( doResize )
		DoResize( true );
	else
		ReDraw( t, &s );
}



//-------------------------------------------------------------------------
// ܂ԂʒuvZ⏕[`
//-------------------------------------------------------------------------

void ViewImpl::UpdateTextCx()
{
	if( cvs_.wrapType() == NOWRAP )
	{
		// ܂ԂȂȂAĂ݂ȂƉ͂킩Ȃ
		ulong cx=0;
		for( ulong i=0, ie=doc_.tln(); i<ie; ++i )
			if( cx < wrap_[i].width() )
				cx = wrap_[i].width();
		textCx_ = cx;
	}
	else
	{
		// ܂ԂȂA:=܂ԂƂ
		textCx_ = cvs_.wrapWidth();
	}
}

ulong ViewImpl::CalcLineWidth( const unicode* txt, ulong len ) const
{
	// s܂ԂɏƂ̉vZ
	// قƂǂ̍s܂Ԃŕ\eLXg̏ꍇA
	// ̒lvZĂƂŁA̍\B
	const Painter& p = cvs_.getPainter();

	ulong w=0;
	for( ulong i=0; i<len; ++i )
		if( txt[i] == L'\t' )
			w = (w/p.T()+1)*p.T();
		else
			w += p.W( txt[i] );
	return w;
}

void ViewImpl::CalcEveryLineWidth()
{
	// SĂ̍sɑ΂CalcLineWidths
	// c邾B
	for( ulong i=0, ie=doc_.tln(); i<ie; ++i )
		wrap_[i].width() = CalcLineWidth( doc_.tl(i), doc_.len(i) );
}

void ViewImpl::ModifyWrapInfo(
		const unicode* txt, ulong len, WLine& wl, ulong stt )
{
	// ݒ蕝ł̐܂ԂsB
	// s̓r̕ύX̏ꍇAsttJnaddresswĂ
	const Painter& p = cvs_.getPainter();
	const ulong   ww = cvs_.wrapWidth();

	while( stt < len )
	{
		ulong i, w;
		for( w=0,i=stt; i<len; ++i )
		{
			if( txt[i] == L'\t' )
				w = (w/p.T()+1)*p.T();
			else
				w += p.W( txt[i] );

			if( w>ww )
				break; // ݒl𒴂ł܂
		}
		wl.Add( stt = (i==stt?i+1:i) );
	}
}

int ViewImpl::GetLastWidth( ulong tl ) const
{
	if( rln(tl)==1 )
		return wrap_[tl][0];

	ulong beg = rlend(tl,rln(tl)-2);
	return CalcLineWidth( doc_.tl(tl)+beg, doc_.len(tl)-beg );
}

void ViewImpl::ReWrapAll()
{
	// ܂ԂɕύXꍇɁASĂ̍s
	// ܂ԂʒuύXB
	const ulong ww = cvs_.wrapWidth();

	ulong vln=0;
	for( ulong i=0, ie=doc_.tln(); i<ie; ++i )
	{
		WLine& wl = wrap_[i];
		wl.ForceSize(1);

		if( wl.width() < ww )
		{
			// ݒ肵܂ԂZꍇ͈sōςށB
			wl.Add( doc_.len(i) );
			++vln;
		}
		else
		{
			// sɂȂꍇ
			ModifyWrapInfo( doc_.tl(i), doc_.len(i), wl, 0 );
			vln += wl.rln();
		}
	}
	vlNum_ = vln;
}



//-------------------------------------------------------------------------
// ܂ԂʒuvZC[`
//-------------------------------------------------------------------------

int ViewImpl::ReWrapSingle( const DPos& s )
{
	// w肵ŝݐ܂ԂCB
	//
	// Ԓl
	//   2: "܂Ԃ" or "̍sɈԒȂ"
	//   1: "̍sȊÔǂŒ"
	//   0: "܂ł̍s͍ŒZȂ"
	// ŁAʃ[`m_TextCxC̕Kv`B
	//
	// ͍̂ĕ`͈͂̌vẐ߂ɁA\s̕ωԂĂA
	// ͏ʃ[` vln() r΍ςނA
	// ނ낻̕Ił邽ߔp~B


	// ۑ
	WLine& wl            = wrap_[s.tl];
	const ulong oldVRNum = wl.rln();
	const ulong oldWidth = wl.width();

	// XV
	wl.width() = CalcLineWidth( doc_.tl(s.tl), doc_.len(s.tl) );

	if( wl.width() < cvs_.wrapWidth() )
	{
		// ݒ肵܂ԂZꍇ͈sōςށB
		wl[1] = doc_.len(s.tl);
		wl.ForceSize( 2 );
	}
	else
	{
		// sɂȂꍇ
		ulong vr=1, stt=0;
		while( wl[vr] < s.ad ) // while( vrsڂ͕ύXӏO )
			stt = wl[ vr++ ];  // stt = ̍s̍s̃AhX

		// ύXӏȍ~̂ݏC
		wl.ForceSize( vr );
		ModifyWrapInfo( doc_.tl(s.tl), doc_.len(s.tl), wl, stt );
	}

	// \s̑C
	vlNum_ += ( wl.rln() - oldVRNum );

	// ܂ԂȂƑ̍XVKv
	if( cvs_.wrapType() == NOWRAP )
		if( textCx_ <= wl.width() )
		{
			textCx_ = wl.width();
			return 2;
		}
		else if( textCx_ == oldWidth )
		{
			return 0;
		}
		else
		{
			return 1;
		}
	return 2;
}

int ViewImpl::InsertMulti( ulong ti_s, ulong ti_e )
{
	// w肵VsǉB
	// ܂ԂƌvZ
	//
	// Ԓl
	//   1: "܂Ԃ" or "̍sɈԒȂ"
	//   0: "̍sȊÔǂŒ"
	// ڂ ReWrapSingle() B

	ulong dy=0, cx=0;
	for( ulong i=ti_s; i<=ti_e; ++i )
	{
		WLine* pwl = new WLine;
		pwl->Add( CalcLineWidth( doc_.tl(i), doc_.len(i) ) );

		if( pwl->width() < cvs_.wrapWidth() )
		{
			// ݒ肵܂ԂZꍇ͈sōςށB
			pwl->Add( doc_.len(i) );
			dy++;
			if( cx < pwl->width() )
				cx = pwl->width();
		}
		else
		{
			// sɂȂꍇ
			ModifyWrapInfo( doc_.tl(i), doc_.len(i), *pwl, 0 );
			dy += pwl->rln();
		}

		wrap_.InsertAt( i, pwl );
	}

	// \s̑C
	vlNum_ += dy;

	// ܂ԂȂƑ̍XVKv
	if( cvs_.wrapType() == NOWRAP )
	{
		if( textCx_ <= cx )
		{
			textCx_ = cx;
			return 1;
		}
		return 0;
	}
	return 1;
}

int ViewImpl::DeleteMulti( ulong ti_s, ulong ti_e )
{
	// w肵͈͂̍s폜
	//
	// Ԓl
	//   1: "܂Ԃ" or "̍sȊÔǂŒ"
	//   0: "܂ł̍s͍ŒZȂ"
	// ڂ ReWrapSingle() B

	bool  widthChanged = false;
	ulong dy = 0;

	// WȂ폜
	for( ulong cx=textCx_, i=ti_s; i<=ti_e; ++i )
	{
		WLine& wl = wrap_[i];
		dy += wl.rln();
		if( cx == wl.width() )
			widthChanged = true;
	}
	wrap_.RemoveAt( ti_s, (ti_e-ti_s+1) );

	// \s̑C
	vlNum_ -= dy;

	// ܂ԂȂƑ̍XVKv
	return ( cvs_.wrapType()==NOWRAP && widthChanged ) ? 0 : 1;
}



//-------------------------------------------------------------------------
// Wlϊ
//-------------------------------------------------------------------------

void ViewImpl::ConvDPosToVPos( DPos dp, VPos* vp, const VPos* base ) const
{
	// ␳
	dp.tl = Min( dp.tl, doc_.tln()-1 );
	dp.ad = Min( dp.ad, doc_.len(dp.tl) );

	// ϊ̊_w肳ĂȂ΁A_Ƃ
	VPos topPos(false); // ONA
	if( base == NULL )
		base = &topPos;

	// Ƃ肠bases̒lĂ
	ulong vl = base->vl - base->rl;
	ulong rl = 0;
	int vx;

	// sꍇ
	//if( dp.tl == base->tl )
	//{
	//	Ⴆ [] ƂȂǁAẺׂ̕
	//	Ŏ̈ʒu͎ZołBgĕʂ
	//	J[\ړ͂ƍł͂ł邪A
	//	Ƃ肠ʓ|̂ŁÂƂ뗪B
	//}

	// Ⴄsꍇ
	//else
	{
		// vl킹
		ulong tl = base->tl;
		if( tl > dp.tl )      // ړInɂꍇ
			do
				vl -= rln(--tl);
			while( tl > dp.tl );
		else if( tl < dp.tl ) // ړIn艺ɂꍇ
			do
				vl += rln(tl++);
			while( tl < dp.tl );

		// rl킹
		ulong stt=0;
		while( wrap_[tl][rl+1] < dp.ad )
			stt = wrap_[tl][++rl];
		vl += rl;

		// xWvZ
		vx = CalcLineWidth( doc_.tl(tl)+stt, dp.ad-stt );
	}

	vp->tl = dp.tl;
	vp->ad = dp.ad;
	vp->vl = vl;
	vp->rl = rl;
	vp->rx = vp->vx = vx;
}

void ViewImpl::GetVPos( int x, int y, VPos* vp, bool linemode ) const
{
// xW␳

	x = x - lna() + rlScr_.nPos;

// ܂sԍvZ

	int tl = udScr_tl_;
	int vl = udScr_.nPos - udScr_vrl_;
	int rl = y / fnt().H() + udScr_vrl_;
	if( rl >= 0 ) // View[艺̏ꍇA𒲂ׂ
		while( tl < (int)doc_.tln() && (int)rln(tl) <= rl )
		{
			vl += rln(tl);
			rl -= rln(tl);
			++tl;
		}
	else           // View[̏ꍇA𒲂ׂ
		while( 0<=tl && rl<0 )
		{
			vl -= rln(tl);
			rl += rln(tl);
			--tl;
		}

	if( tl == (int)doc_.tln() ) // EOF艺ɍsĂ܂ꍇ̕␳
	{
		--tl, vl-=rln(tl), rl=rln(tl)-1;
		if( linemode )
			x = 0x4fffffff;
	}
	else if( tl == -1 ) // t@CɍsĂ܂ꍇ̕␳
	{
		tl = vl = rl = 0;
		if( linemode )
			x = 0;
	}
	else
	{
		if( linemode ) // sI[h̏ꍇ
		{
			if( tl == (int)doc_.tln()-1 )
				rl=rln(tl)-1, x=0x4fffffff;
			else
				vl+=rln(tl), rl=0, ++tl, x=0;
		}
	}

	vp->tl = tl;
	vp->vl = vl + rl;
	vp->rl = rl;

// ɁAʒuvZ

	const unicode* str = doc_.tl(tl);
	const ulong adend = rlend(tl,rl);
	ulong ad = (rl==0 ? 0 : rlend(tl,rl-1));
	int   vx = (rl==0 ? 0 : fnt().W(str[ad++]));

	while( ad<adend )
	{
		int nvx = (str[ad]==L'\t'
			? (vx/fnt().T()+1)*fnt().T()
			:  vx + fnt().W(str[ad])
		);
		if( x+2 < nvx )
			break;
		vx = nvx;
		++ad;
	}

	vp->ad          = ad;
	vp->rx = vp->vx = vx;
}
